; PARSEA.ASM

; LoadFormul(Formula) : void
; Token=NextToken() : char
; Typet=NextTypet() : integer
; Pos=PosError() : integer
; Error=NextParen() : boolean
; Error=NextComma() : boolean
; Cells=NextCells() : char

PUBLIC LoadFormul
PUBLIC NextToken
PUBLIC NextTypet
PUBLIC PosError
PUBLIC NextParen
PUBLIC NextComma
PUBLIC NextCells

INCLUDE EXTENDA.MAC

EOL	= 0	; end string
PLUS	= 1	; +
MINUS	= 2	; -
TIMES	= 3	; *
DIVIDE	= 4	; /
OPAREN	= 5	; (
COMMA	= 6	; ,
CPAREN	= 7	; )
EXPO	= 8	; ^
NUM	= 9	; number value
CELL	= 10	; name value
FUN	= 11	; int(var1)
IIF	= 12	; iif(var1,var2,var3)
BAD	= 13	; 
CASE	= 14	; case(var1,var2,var3)
SEMIC	= 15	; ; string

LEN_CELL= 10
LEN_NUM = 25

DGROUP	GROUP	DATASG		; Combine your data segment
				; with Clipper's.
DATASG	SEGMENT	'_DATA'		; Start of data segment.

formul	label	dword
frm_bx	dw	0
frm_es	dw	0
beg_bx	dw	0
token	db	LEN_NUM+1	dup(0)
typet	dw	0
cells	db	LEN_CELL+1	dup(0)

DATASG	ENDS			; End of data segment.
;
_PROG	segment	'CODE'		; Start of code segment.
	ASSUME	cs:_PROG,ds:DGROUP
;
LoadFormul	PROC	FAR
	GET_CHAR	1
	mov	frm_es, DX
	mov	frm_bx, AX
	mov	beg_bx, AX
	RET_VOID
	ret
LoadFormul	ENDP
;
NextToken	PROC	FAR
	PushStack	<DS,ES,DI,SI>
	les	BX, formul
	xor	DI, DI
	mov	AL, ES:[BX]
	cmp	AL, EOL
	jne	@endif1
		mov	token, EOL
		mov	typet, EOL
		jmp	near ptr @exit
	@endif1:
	cmp	AL, '.'
	je	@then2
	cmp	AL, '0'
	jb	@endif2
	cmp	AL, '9'
	ja	@endif2
	@then2:
		cmp	AL, '.'
		jne	@endif3
			mov	token, '0'
			inc DI
		@endif3:
		mov	AH, FALSE	; decimal
		@repeat2:
			mov	token[DI], AL
			cmp	AL, '.'
			jne	@endif4
				cmp	AH, FALSE
				jne	@else5
					mov	AH, TRUE
				jmp	short @endif5
				@else5:
					mov	token[DI], EOL
					mov	typet, BAD
					jmp	near ptr @exit
				@endif5:
			@endif4:
			inc	BX
			inc	DI
			mov	AL, ES:[BX]
		cmp	AL, '.'
		je	@repeat2
		cmp	AL, '0'
		jb	@until2
		cmp	AL, '9'
		ja	@until2
		jmp	short @repeat2
		@until2:
		mov	token[DI], EOL
		cmp	DI, LEN_NUM
		jbe	@endif7
			mov	typet, BAD
			jmp	near ptr @exit
		@endif7:
		mov	typet, NUM
		jmp	near ptr @exit
	@endif2:
	cmp	AL, 'A'
	jb	@if6and1
	cmp	AL, 'Z'
	ja	@if6and1
	jmp	short @then6
	@if6and1:
	jmp	near ptr @endif6
	@then6:
		@repeat3:
			mov	token[DI], AL
			inc	BX
			inc	DI
			mov	AL, ES:[BX]
		cmp	AL, '0'
		jb	@re3and1
		cmp	AL, '9'
		ja	@re3and1
		jmp	short @repeat3
		@re3and1:
		cmp	AL, 'A'
		jb	@re3and2
		cmp	AL, 'Z'
		ja	@re3and2
		jmp	short @repeat3
		@re3and2:
		mov	token[DI], EOL
		cmp	DI, LEN_CELL
		jbe	@endif8
			mov	typet, BAD
			jmp	near ptr @exit
		@endif8:
		cmp	AL, '('
		je	@0001
		jmp	near ptr @endif9
		@0001:
			inc	BX
			mov	token[DI], AL
			inc	DI
			mov	token[DI], EOL
			mov	AL, token
			mov	AH, token+1
			mov	DL, token+2
			mov	DH, token+3
			mov	CL, token+4
			; if token = IIF(
			cmp	AL, 'I'
			jne	@endif10
			cmp	AH, 'I'
			jne	@endif10
			cmp	DL, 'F'
			jne	@endif10
			cmp	DH, '('
			jne	@endif10
				mov	typet, IIF
				jmp	near ptr @exit
			@endif10:
			; if token = CASE(
			cmp	AL, 'C'
			jne	@endif10_1
			cmp	AH, 'A'
			jne	@endif10_1
			cmp	DL, 'S'
			jne	@endif10_1
			cmp	DH, 'E'
			jne	@endif10_1
			cmp	CL, '('
			jne	@endif10_1
				mov	typet, CASE
				jmp	near ptr @exit
			@endif10_1:
			; if token = INT(
			cmp	AL, 'I'
			jne	@if11and1
			cmp	AH, 'N'
			jne	@if11and1
			cmp	DL, 'T'
			jne	@if11and1
			cmp	DH, '('
			je	@then11
			@if11and1:
			; if token = INR(
			cmp	AL, 'I'
			jne	@if11and2
			cmp	AH, 'N'
			jne	@if11and2
			cmp	DL, 'R'
			jne	@if11and2
			cmp	DH, '('
			je	@then11
			@if11and2:
			; if token = ABS(
			cmp	AL, 'A'
			jne	@if11and3
			cmp	AH, 'B'
			jne	@if11and3
			cmp	DL, 'S'
			jne	@if11and3
			cmp	DH, '('
			je	@then11
			@if11and3:
			; if token = EXP(
			cmp	AL, 'E'
			jne	@if11and4
			cmp	AH, 'X'
			jne	@if11and4
			cmp	DL, 'P'
			jne	@if11and4
			cmp	DH, '('
			je	@then11
			@if11and4:
			; if token = LOG(
			cmp	AL, 'L'
			jne	@if11and5
			cmp	AH, 'O'
			jne	@if11and5
			cmp	DL, 'G'
			jne	@if11and5
			cmp	DH, '('
			je	@then11
			@if11and5:
			; if token = SQRT(
			cmp	AL, 'S'
			jne	@if11and6
			cmp	AH, 'Q'
			jne	@if11and6
			cmp	DL, 'R'
			jne	@if11and6
			cmp	DL, 'T'
			jne	@if11and6
			cmp	CL, '('
			je	@then11
			@if11and6:
			; if token = SQR(
			cmp	AL, 'S'
			jne	@endif11
			cmp	AH, 'Q'
			jne	@endif11
			cmp	DL, 'R'
			jne	@endif11
			cmp	DH, '('
			jne	@endif11
			@then11:
				mov	typet, FUN
				jmp	near ptr @exit
			@endif11:
			mov	typet, BAD
			jmp	near ptr @exit
		@endif9:
		mov	typet, CELL
		jmp	short @exit
	@endif6:
	cmp	AL, '+'
	je	@case1$1
	cmp	AL, '-'
	je	@case1$2
	cmp	AL, '*'
	je	@case1$3
	cmp	AL, '/'
	je	@case1$4
	cmp	AL, '('
	je	@case1$5
	cmp	AL, ')'
	je	@case1$6
	cmp	AL, ','
	je	@case1$7
	cmp	AL, '^'
	je	@case1$8
	cmp	AL, ';'
	je	@case1$9
		mov	typet, BAD
	jmp	short @endcase1
	@case1$1:
		mov	typet, PLUS
	jmp	short @endcase1
	@case1$2:
		mov	typet, MINUS
	jmp	short @endcase1
	@case1$3:
		mov	typet, TIMES
	jmp	short @endcase1
	@case1$4:
		mov	typet, DIVIDE
	jmp	short @endcase1
	@case1$5:
		mov	typet, OPAREN
	jmp	short @endcase1
	@case1$6:
		mov	typet, CPAREN
	jmp	short @endcase1
	@case1$7:
		mov	typet, COMMA
	jmp	short @endcase1
	@case1$8:
		mov	typet, EXPO
	jmp	short @endcase1
	@case1$9:
		mov	typet, SEMIC
	@endcase1:
	mov	token, AL
	mov	token+1, EOL
	inc	BX
@exit:
	mov	frm_bx, BX
	PopStack	<SI,DI,ES,DS>
	mov	DX, SEG token
	mov	AX, OFFSET token
	RET_CHAR	DX, AX
	ret
NextToken	ENDP
;
NextTypet	PROC	FAR
	mov	AX, typet
	RET_INT	AX
	ret
NextTypet	ENDP
;
NextParen	PROC	FAR
	mov	CX, 1
	mov	DX, TRUE
	les	BX, formul
	@repeat4:
		mov	AL, ES:[BX]
		inc	BX
		cmp	AL, '('
		je	@case2$1
		cmp	AL, ')'
		je	@case2$2
		jmp	short @endcase2
		@case2$1:
			inc	CX
		jmp	short @endcase2
		@case2$2:
			dec	CX
		@endcase2:
		cmp	CX, 0
		jne	@endif12
		cmp	AL, ')'
		jne	@endif12
			mov	DX, FALSE
			jmp	short @exit1
		@endif12:
	cmp	AL, EOL
	je	@exit1
	cmp	AL, ';'
	jne	@repeat4
@exit1:
	mov	frm_bx, BX
	RET_LOGICAL	DX
	ret
NextParen	ENDP
;
NextComma	PROC	FAR
	mov	CX, 0
	mov	DX, TRUE
	les	BX, formul
	@repeat5:
		mov	AL, ES:[BX]
		inc	BX
		cmp	AL, '('
		je	@case3$1
		cmp	AL, ')'
		je	@case3$2
		jmp	short @endcase3
		@case3$1:
			inc	CX
		jmp	short @endcase3
		@case3$2:
			dec	CX
		@endcase3:
		cmp	CX, 0
		jne	@endif13
		cmp	AL, ','
		jne	@endif13
			mov	DX, FALSE
			jmp	short @exit2
		@endif13:
	cmp	AL, EOL
	je	@exit2
	cmp	AL, ';'
	jne	@repeat5
@exit2:
	mov	frm_bx, BX
	RET_LOGICAL	DX
	ret
NextComma	ENDP
;
PosError	PROC	FAR
	mov	AX, frm_bx
	sub	AX, beg_bx
	RET_INT	AX
	ret
PosError	ENDP
;
NextCells	PROC	FAR
	PushStack	<DS,ES,DI>
	les	BX, formul
	xor	DI, DI
	mov	AL, ES:[BX]
	cmp	AL, 'A'
	jb	@if14and1
	cmp	AL, 'Z'
	ja	@if14and1
	jmp	short @then14
	@if14and1:
	jmp	near ptr @endif14
	@then14:
		@repeat6:
			mov	cells[DI], AL
			inc	BX
			inc	DI
			mov	AL, ES:[BX]
		cmp	AL, '='		;   ᭠砫 pp '='
		je	@until6
		cmp	DI, LEN_CELL	;  ⮬ LEN_CELL
		je	@until6
		cmp	AL, '0'
		jb	@re6and1
		cmp	AL, '9'
		ja	@re6and1
		jmp	short @repeat6
		@re6and1:
		cmp	AL, 'A'
		jb	@re6and2
		cmp	AL, 'Z'
		ja	@re6and2
		jmp	short @repeat6
		@re6and2:
		@until6:
	@endif14:
	cmp	AL, '='
	jne	@else15
		mov	cells[DI], EOL
		inc	BX
		mov	frm_bx, BX
	jmp	short @endif15
	@else15:
		mov	cells, EOL
	@endif15:
	PopStack	<DI,ES,DS>
	mov	DX, SEG cells
	mov	AX, OFFSET cells
	RET_CHAR	DX, AX
	ret
NextCells	ENDP
;
_PROG	ENDS
	END
